git-fetch.shon commit Merge branch 'jc/diff' into next (514236a)
   1#!/bin/sh
   2#
   3
   4USAGE='<fetch-options> <repository> <refspec>...'
   5. git-sh-setup
   6. git-parse-remote
   7_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
   8_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
   9
  10LF='
  11'
  12IFS="$LF"
  13
  14no_tags=
  15tags=
  16append=
  17force=
  18verbose=
  19update_head_ok=
  20exec=
  21upload_pack=
  22while case "$#" in 0) break ;; esac
  23do
  24        case "$1" in
  25        -a|--a|--ap|--app|--appe|--appen|--append)
  26                append=t
  27                ;;
  28        --upl|--uplo|--uploa|--upload|--upload-|--upload-p|\
  29        --upload-pa|--upload-pac|--upload-pack)
  30                shift
  31                exec="--exec=$1" 
  32                upload_pack="-u $1"
  33                ;;
  34        -f|--f|--fo|--for|--forc|--force)
  35                force=t
  36                ;;
  37        -t|--t|--ta|--tag|--tags)
  38                tags=t
  39                ;;
  40        -n|--n|--no|--no-|--no-t|--no-ta|--no-tag|--no-tags)
  41                no_tags=t
  42                ;;
  43        -u|--u|--up|--upd|--upda|--updat|--update|--update-|--update-h|\
  44        --update-he|--update-hea|--update-head|--update-head-|\
  45        --update-head-o|--update-head-ok)
  46                update_head_ok=t
  47                ;;
  48        -v|--verbose)
  49                verbose=Yes
  50                ;;
  51        -k|--k|--ke|--kee|--keep)
  52                keep=--keep
  53                ;;
  54        -*)
  55                usage
  56                ;;
  57        *)
  58                break
  59                ;;
  60        esac
  61        shift
  62done
  63
  64case "$#" in
  650)
  66        test -f "$GIT_DIR/branches/origin" ||
  67                test -f "$GIT_DIR/remotes/origin" ||
  68                        die "Where do you want to fetch from today?"
  69        set origin ;;
  70esac
  71
  72remote_nick="$1"
  73remote=$(get_remote_url "$@")
  74refs=
  75rref=
  76rsync_slurped_objects=
  77
  78if test "" = "$append"
  79then
  80        : >"$GIT_DIR/FETCH_HEAD"
  81fi
  82
  83append_fetch_head () {
  84    head_="$1"
  85    remote_="$2"
  86    remote_name_="$3"
  87    remote_nick_="$4"
  88    local_name_="$5"
  89    case "$6" in
  90    t) not_for_merge_='not-for-merge' ;;
  91    '') not_for_merge_= ;;
  92    esac
  93
  94    # remote-nick is the URL given on the command line (or a shorthand)
  95    # remote-name is the $GIT_DIR relative refs/ path we computed
  96    # for this refspec.
  97
  98    # the $note_ variable will be fed to git-fmt-merge-msg for further
  99    # processing.
 100    case "$remote_name_" in
 101    HEAD)
 102        note_= ;;
 103    refs/heads/*)
 104        note_="$(expr "$remote_name_" : 'refs/heads/\(.*\)')"
 105        note_="branch '$note_' of " ;;
 106    refs/tags/*)
 107        note_="$(expr "$remote_name_" : 'refs/tags/\(.*\)')"
 108        note_="tag '$note_' of " ;;
 109    refs/remotes/*)
 110        note_="$(expr "$remote_name_" : 'refs/remotes/\(.*\)')"
 111        note_="remote branch '$note_' of " ;;
 112    *)
 113        note_="$remote_name of " ;;
 114    esac
 115    remote_1_=$(expr "$remote_" : '\(.*\)\.git/*$') &&
 116        remote_="$remote_1_"
 117    note_="$note_$remote_"
 118
 119    # 2.6.11-tree tag would not be happy to be fed to resolve.
 120    if git-cat-file commit "$head_" >/dev/null 2>&1
 121    then
 122        headc_=$(git-rev-parse --verify "$head_^0") || exit
 123        echo "$headc_   $not_for_merge_ $note_" >>"$GIT_DIR/FETCH_HEAD"
 124        [ "$verbose" ] && echo >&2 "* committish: $head_"
 125        [ "$verbose" ] && echo >&2 "  $note_"
 126    else
 127        echo "$head_    not-for-merge   $note_" >>"$GIT_DIR/FETCH_HEAD"
 128        [ "$verbose" ] && echo >&2 "* non-commit: $head_"
 129        [ "$verbose" ] && echo >&2 "  $note_"
 130    fi
 131    if test "$local_name_" != ""
 132    then
 133        # We are storing the head locally.  Make sure that it is
 134        # a fast forward (aka "reverse push").
 135        fast_forward_local "$local_name_" "$head_" "$note_"
 136    fi
 137}
 138
 139fast_forward_local () {
 140    mkdir -p "$(dirname "$GIT_DIR/$1")"
 141    case "$1" in
 142    refs/tags/*)
 143        # Tags need not be pointing at commits so there
 144        # is no way to guarantee "fast-forward" anyway.
 145        if test -f "$GIT_DIR/$1"
 146        then
 147                if now_=$(cat "$GIT_DIR/$1") && test "$now_" = "$2"
 148                then
 149                        [ "$verbose" ] && echo >&2 "* $1: same as $3"
 150                else
 151                        echo >&2 "* $1: updating with $3"
 152                fi
 153        else
 154                echo >&2 "* $1: storing $3"
 155        fi
 156        git-update-ref "$1" "$2"
 157        ;;
 158
 159    refs/heads/* | refs/remotes/*)
 160        # $1 is the ref being updated.
 161        # $2 is the new value for the ref.
 162        local=$(git-rev-parse --verify "$1^0" 2>/dev/null)
 163        if test "$local"
 164        then
 165            # Require fast-forward.
 166            mb=$(git-merge-base "$local" "$2") &&
 167            case "$2,$mb" in
 168            $local,*)
 169                echo >&2 "* $1: same as $3"
 170                ;;
 171            *,$local)
 172                echo >&2 "* $1: fast forward to $3"
 173                echo >&2 "  from $local to $2"
 174                git-update-ref "$1" "$2" "$local"
 175                ;;
 176            *)
 177                false
 178                ;;
 179            esac || {
 180                echo >&2 "* $1: does not fast forward to $3;"
 181                case ",$force,$single_force," in
 182                *,t,*)
 183                        echo >&2 "  forcing update."
 184                        git-update-ref "$1" "$2" "$local"
 185                        ;;
 186                *)
 187                        echo >&2 "  not updating."
 188                        ;;
 189                esac
 190            }
 191        else
 192            echo >&2 "* $1: storing $3"
 193            git-update-ref "$1" "$2"
 194        fi
 195        ;;
 196    esac
 197}
 198
 199case "$update_head_ok" in
 200'')
 201        orig_head=$(git-rev-parse --verify HEAD 2>/dev/null)
 202        ;;
 203esac
 204
 205# If --tags (and later --heads or --all) is specified, then we are
 206# not talking about defaults stored in Pull: line of remotes or
 207# branches file, and just fetch those and refspecs explicitly given.
 208# Otherwise we do what we always did.
 209
 210reflist=$(get_remote_refs_for_fetch "$@")
 211if test "$tags"
 212then
 213        taglist=$(IFS=" " &&
 214                  git-ls-remote $upload_pack --tags "$remote" |
 215                  while read sha1 name
 216                  do
 217                        case "$name" in
 218                        (*^*) continue ;;
 219                        esac
 220                        if git-check-ref-format "$name"
 221                        then
 222                            echo ".${name}:${name}"
 223                        else
 224                            echo >&2 "warning: tag ${name} ignored"
 225                        fi
 226                  done)
 227        if test "$#" -gt 1
 228        then
 229                # remote URL plus explicit refspecs; we need to merge them.
 230                reflist="$reflist$LF$taglist"
 231        else
 232                # No explicit refspecs; fetch tags only.
 233                reflist=$taglist
 234        fi
 235fi
 236
 237fetch_main () {
 238  reflist="$1"
 239  refs=
 240
 241  for ref in $reflist
 242  do
 243      refs="$refs$LF$ref"
 244
 245      # These are relative path from $GIT_DIR, typically starting at refs/
 246      # but may be HEAD
 247      if expr "$ref" : '\.' >/dev/null
 248      then
 249          not_for_merge=t
 250          ref=$(expr "$ref" : '\.\(.*\)')
 251      else
 252          not_for_merge=
 253      fi
 254      if expr "$ref" : '\+' >/dev/null
 255      then
 256          single_force=t
 257          ref=$(expr "$ref" : '\+\(.*\)')
 258      else
 259          single_force=
 260      fi
 261      remote_name=$(expr "$ref" : '\([^:]*\):')
 262      local_name=$(expr "$ref" : '[^:]*:\(.*\)')
 263
 264      rref="$rref$LF$remote_name"
 265
 266      # There are transports that can fetch only one head at a time...
 267      case "$remote" in
 268      http://* | https://*)
 269          if [ -n "$GIT_SSL_NO_VERIFY" ]; then
 270              curl_extra_args="-k"
 271          fi
 272          remote_name_quoted=$(perl -e '
 273              my $u = $ARGV[0];
 274              $u =~ s{([^-a-zA-Z0-9/.])}{sprintf"%%%02x",ord($1)}eg;
 275              print "$u";
 276          ' "$remote_name")
 277          head=$(curl -nsfL $curl_extra_args "$remote/$remote_name_quoted") &&
 278          expr "$head" : "$_x40\$" >/dev/null ||
 279                  die "Failed to fetch $remote_name from $remote"
 280          echo >&2 Fetching "$remote_name from $remote" using http
 281          git-http-fetch -v -a "$head" "$remote/" || exit
 282          ;;
 283      rsync://*)
 284          TMP_HEAD="$GIT_DIR/TMP_HEAD"
 285          rsync -L -q "$remote/$remote_name" "$TMP_HEAD" || exit 1
 286          head=$(git-rev-parse --verify TMP_HEAD)
 287          rm -f "$TMP_HEAD"
 288          test "$rsync_slurped_objects" || {
 289              rsync -av --ignore-existing --exclude info \
 290                  "$remote/objects/" "$GIT_OBJECT_DIRECTORY/" || exit
 291
 292              # Look at objects/info/alternates for rsync -- http will
 293              # support it natively and git native ones will do it on
 294              # the remote end.  Not having that file is not a crime.
 295              rsync -q "$remote/objects/info/alternates" \
 296                  "$GIT_DIR/TMP_ALT" 2>/dev/null ||
 297                  rm -f "$GIT_DIR/TMP_ALT"
 298              if test -f "$GIT_DIR/TMP_ALT"
 299              then
 300                  resolve_alternates "$remote" <"$GIT_DIR/TMP_ALT" |
 301                  while read alt
 302                  do
 303                      case "$alt" in 'bad alternate: '*) die "$alt";; esac
 304                      echo >&2 "Getting alternate: $alt"
 305                      rsync -av --ignore-existing --exclude info \
 306                      "$alt" "$GIT_OBJECT_DIRECTORY/" || exit
 307                  done
 308                  rm -f "$GIT_DIR/TMP_ALT"
 309              fi
 310              rsync_slurped_objects=t
 311          }
 312          ;;
 313      *)
 314          # We will do git native transport with just one call later.
 315          continue ;;
 316      esac
 317
 318      append_fetch_head "$head" "$remote" \
 319          "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
 320
 321  done
 322
 323  case "$remote" in
 324  http://* | https://* | rsync://* )
 325      ;; # we are already done.
 326  *)
 327    ( : subshell because we muck with IFS
 328      IFS="     $LF"
 329      (
 330          git-fetch-pack $exec $keep --thin "$remote" $rref || echo failed "$remote"
 331      ) |
 332      while read sha1 remote_name
 333      do
 334          case "$sha1" in
 335          failed)
 336                  echo >&2 "Fetch failure: $remote"
 337                  exit 1 ;;
 338          esac
 339          found=
 340          single_force=
 341          for ref in $refs
 342          do
 343              case "$ref" in
 344              +$remote_name:*)
 345                  single_force=t
 346                  not_for_merge=
 347                  found="$ref"
 348                  break ;;
 349              .+$remote_name:*)
 350                  single_force=t
 351                  not_for_merge=t
 352                  found="$ref"
 353                  break ;;
 354              .$remote_name:*)
 355                  not_for_merge=t
 356                  found="$ref"
 357                  break ;;
 358              $remote_name:*)
 359                  not_for_merge=
 360                  found="$ref"
 361                  break ;;
 362              esac
 363          done
 364          local_name=$(expr "$found" : '[^:]*:\(.*\)')
 365          append_fetch_head "$sha1" "$remote" \
 366                  "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
 367      done
 368    ) || exit ;;
 369  esac
 370
 371}
 372
 373fetch_main "$reflist"
 374
 375# automated tag following
 376case "$no_tags$tags" in
 377'')
 378        case "$reflist" in
 379        *:refs/*)
 380                # effective only when we are following remote branch
 381                # using local tracking branch.
 382                taglist=$(IFS=" " &&
 383                git-ls-remote $upload_pack --tags "$remote" |
 384                sed -ne 's|^\([0-9a-f]*\)[      ]\(refs/tags/.*\)^{}$|\1 \2|p' |
 385                while read sha1 name
 386                do
 387                        test -f "$GIT_DIR/$name" && continue
 388                        git-check-ref-format "$name" || {
 389                                echo >&2 "warning: tag ${name} ignored"
 390                                continue
 391                        }
 392                        git-cat-file -t "$sha1" >/dev/null 2>&1 || continue
 393                        echo >&2 "Auto-following $name"
 394                        echo ".${name}:${name}"
 395                done)
 396        esac
 397        case "$taglist" in
 398        '') ;;
 399        ?*)
 400                fetch_main "$taglist" ;;
 401        esac
 402esac
 403
 404# If the original head was empty (i.e. no "master" yet), or
 405# if we were told not to worry, we do not have to check.
 406case ",$update_head_ok,$orig_head," in
 407*,, | t,* )
 408        ;;
 409*)
 410        curr_head=$(git-rev-parse --verify HEAD 2>/dev/null)
 411        if test "$curr_head" != "$orig_head"
 412        then
 413                git-update-ref HEAD "$orig_head"
 414                die "Cannot fetch into the current branch."
 415        fi
 416        ;;
 417esac